GIT a69683413d17070b7cc43c2f62f956683130abd8 git+ssh://master.kernel.org/pub/scm/linux/kernel/git/jgarzik/misc-2.6.git#gccbug

commit a69683413d17070b7cc43c2f62f956683130abd8
Author: Paolo 'Blaisorblade' Giarrusso <blaisorblade@yahoo.it>
Date:   Sat Nov 18 03:44:01 2006 +0100

    [PATCH] Kill gcc warning verified as bogus.
    
    Signed-off-by: Paolo 'Blaisorblade' Giarrusso <blaisorblade@yahoo.it>
    Signed-off-by: Jeff Garzik <jeff@garzik.org>

commit d50915901d4349e16ab324547f1e3bbc95229555
Author: Paolo 'Blaisorblade' Giarrusso <blaisorblade@yahoo.it>
Date:   Sat Nov 18 03:43:59 2006 +0100

    [PATCH] Kill gcc warning verified as bogus.
    
    Signed-off-by: Paolo 'Blaisorblade' Giarrusso <blaisorblade@yahoo.it>
    Signed-off-by: Jeff Garzik <jeff@garzik.org>

commit a6efd288ff0e8dc6a9bad7fb9cd27114b72803a7
Author: Jeff Garzik <jeff@garzik.org>
Date:   Tue Oct 10 20:49:49 2006 -0400

    drivers/net, drivers/net: Silence more bogosities

commit 53a062d36e82047c6215c463c24b718259687321
Author: Jeff Garzik <jeff@garzik.org>
Date:   Tue Oct 10 11:05:04 2006 -0400

    [DM] kill bogus uninit warning

commit fe1e7e2cde82958c532d5b25411a94d7a6c76417
Author: Jeff Garzik <jeff@garzik.org>
Date:   Tue Oct 10 02:28:48 2006 -0400

    arch/i386/kernel/efi: kill invalid 'may be used uninit' warning

commit ebedec5bbf2a254d4422b3f44689d34ac62124ec
Author: Jeff Garzik <jeff@garzik.org>
Date:   Sat Oct 7 19:45:52 2006 -0400

    drivers/atm/zatm: fix warning

commit 904b15dd4ad66d2106f0713a218ce77c4ce0e9cf
Author: Jeff Garzik <jeff@garzik.org>
Date:   Thu Oct 5 09:08:57 2006 -0400

    drivers/ide/pci/jmicron: Kill bogus gcc warning

commit accb90fc90a89d8ecd4ee2e5549026759c9827b1
Author: Jeff Garzik <jeff@garzik.org>
Date:   Sun Oct 1 15:11:00 2006 -0400

    Kill gcc warnings verified as bogus.

commit 9fac8d2738982db8963ffa0f5f6141db2e1ee405
Author: Jeff Garzik <jeff@garzik.org>
Date:   Sun Oct 1 12:51:28 2006 -0400

    Kill gcc warnings verified as bogus.

commit 2ea47f44ab2790eb4a852ea0f942a3da768c2038
Author: Jeff Garzik <jeff@garzik.org>
Date:   Sun Oct 1 11:24:27 2006 -0400

    Kill gcc warnings verified as bogus.

commit 8bf7b468e6747aec66be0b15c599ee76505d6f8d
Author: Jeff Garzik <jeff@garzik.org>
Date:   Sun Oct 1 09:36:14 2006 -0400

    Kill gcc warnings verified as bogus.
Signed-off-by: Andrew Morton <akpm@linux-foundation.org>
 arch/i386/kernel/efi.c                 |    2 ++
 drivers/atm/zatm.c                     |    4 +++-
 drivers/ide/pci/jmicron.c              |    3 ++-
 drivers/infiniband/hw/mthca/mthca_qp.c |    4 ++--
 drivers/md/dm-exception-store.c        |    2 +-
 drivers/net/r8169.c                    |    2 +-
 drivers/net/tokenring/smctr.c          |    2 +-
 drivers/net/wan/sbni.c                 |    2 +-
 drivers/usb/misc/auerswald.c           |    2 +-
 drivers/video/matrox/matroxfb_maven.c  |    4 ++--
 drivers/video/riva/riva_hw.c           |    2 +-
 fs/block_dev.c                         |    2 +-
 fs/jfs/jfs_txnmgr.c                    |    2 ++
 fs/nfsd/nfsctl.c                       |    2 +-
 fs/ocfs2/dlm/dlmdomain.c               |    2 +-
 fs/ocfs2/vote.c                        |    2 +-
 fs/udf/balloc.c                        |    2 ++
 fs/udf/super.c                         |    2 ++
 ipc/msg.c                              |    2 ++
 ipc/sem.c                              |    2 ++
 kernel/auditfilter.c                   |    2 +-
 21 files changed, 32 insertions(+), 17 deletions(-)

Index: linux-2.6.21-rc5/arch/i386/kernel/efi.c
===================================================================
--- linux-2.6.21-rc5.orig/arch/i386/kernel/efi.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/arch/i386/kernel/efi.c	2007-04-03 17:14:55.000000000 +0100
@@ -283,6 +283,8 @@ void efi_memmap_walk(efi_freemem_callbac
 	unsigned long start, end;
 	void *p;
 
+	prev.start = prev.end = 0;
+
 	for (p = memmap.map; p < memmap.map_end; p += memmap.desc_size) {
 		md = p;
 
Index: linux-2.6.21-rc5/drivers/atm/zatm.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/atm/zatm.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/drivers/atm/zatm.c	2007-04-03 17:14:55.000000000 +0100
@@ -915,7 +915,7 @@ static int open_tx_first(struct atm_vcc 
 	unsigned long flags;
 	u32 *loop;
 	unsigned short chan;
-	int pcr,unlimited;
+	int unlimited;
 
 	DPRINTK("open_tx_first\n");
 	zatm_dev = ZATM_DEV(vcc->dev);
@@ -936,6 +936,8 @@ static int open_tx_first(struct atm_vcc 
 	    vcc->qos.txtp.max_pcr >= ATM_OC3_PCR);
 	if (unlimited && zatm_dev->ubr != -1) zatm_vcc->shaper = zatm_dev->ubr;
 	else {
+		int pcr = 0;
+
 		if (unlimited) vcc->qos.txtp.max_sdu = ATM_MAX_AAL5_PDU;
 		if ((zatm_vcc->shaper = alloc_shaper(vcc->dev,&pcr,
 		    vcc->qos.txtp.min_pcr,vcc->qos.txtp.max_pcr,unlimited))
Index: linux-2.6.21-rc5/drivers/ide/pci/jmicron.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/ide/pci/jmicron.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/drivers/ide/pci/jmicron.c	2007-04-03 17:14:55.000000000 +0100
@@ -95,7 +95,8 @@ static int __devinit ata66_jmicron(ide_h
 	case PORT_SATA:
 		break;
 	}
-	return 1; /* Avoid bogus "control reaches end of non-void function" */
+
+	return 0;	/* kill gcc warning */
 }
 
 static void jmicron_tuneproc (ide_drive_t *drive, byte mode_wanted)
Index: linux-2.6.21-rc5/drivers/infiniband/hw/mthca/mthca_qp.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/infiniband/hw/mthca/mthca_qp.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/drivers/infiniband/hw/mthca/mthca_qp.c	2007-04-03 17:14:55.000000000 +0100
@@ -1540,7 +1540,7 @@ int mthca_tavor_post_send(struct ib_qp *
 	int i;
 	int size;
 	int size0 = 0;
-	u32 f0;
+	u32 f0 = 0;
 	int ind;
 	u8 op0 = 0;
 
@@ -1894,7 +1894,7 @@ int mthca_arbel_post_send(struct ib_qp *
 	int i;
 	int size;
 	int size0 = 0;
-	u32 f0;
+	u32 f0 = 0;
 	int ind;
 	u8 op0 = 0;
 
Index: linux-2.6.21-rc5/drivers/md/dm-exception-store.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/md/dm-exception-store.c	2007-04-03 17:14:49.000000000 +0100
+++ linux-2.6.21-rc5/drivers/md/dm-exception-store.c	2007-04-03 17:14:55.000000000 +0100
@@ -417,7 +417,7 @@ static void persistent_destroy(struct ex
 
 static int persistent_read_metadata(struct exception_store *store)
 {
-	int r, new_snapshot;
+	int r, new_snapshot = 0;
 	struct pstore *ps = get_info(store);
 
 	/*
Index: linux-2.6.21-rc5/drivers/net/r8169.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/net/r8169.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/drivers/net/r8169.c	2007-04-03 17:14:55.000000000 +0100
@@ -2239,7 +2239,7 @@ static int rtl8169_xmit_frags(struct rtl
 {
 	struct skb_shared_info *info = skb_shinfo(skb);
 	unsigned int cur_frag, entry;
-	struct TxDesc *txd;
+	struct TxDesc *txd = NULL;
 
 	entry = tp->cur_tx;
 	for (cur_frag = 0; cur_frag < info->nr_frags; cur_frag++) {
Index: linux-2.6.21-rc5/drivers/net/tokenring/smctr.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/net/tokenring/smctr.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/drivers/net/tokenring/smctr.c	2007-04-03 17:14:55.000000000 +0100
@@ -3693,7 +3693,7 @@ static int smctr_process_rx_packet(MAC_H
         __u16 rcode, correlator;
         int err = 0;
         __u8 xframe = 1;
-        __u16 tx_fstatus;
+        __u16 tx_fstatus = 0;
 
         rmf->vl = SWAP_BYTES(rmf->vl);
         if(rx_status & FCB_RX_STATUS_DA_MATCHED)
Index: linux-2.6.21-rc5/drivers/net/wan/sbni.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/net/wan/sbni.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/drivers/net/wan/sbni.c	2007-04-03 17:14:55.000000000 +0100
@@ -595,7 +595,7 @@ recv_frame( struct net_device  *dev )
 
 	u32  crc = CRC32_INITIAL;
 
-	unsigned  framelen, frameno, ack;
+	unsigned  framelen = 0, frameno, ack;
 	unsigned  is_first, frame_ok;
 
 	if( check_fhdr( ioaddr, &framelen, &frameno, &ack, &is_first, &crc ) ) {
Index: linux-2.6.21-rc5/drivers/usb/misc/auerswald.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/usb/misc/auerswald.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/drivers/usb/misc/auerswald.c	2007-04-03 17:14:55.000000000 +0100
@@ -664,7 +664,7 @@ static int auerchain_control_msg (pauerc
 	int ret;
 	struct usb_ctrlrequest *dr;
 	struct urb *urb;
-        int length;
+        int length = 0;
 
         dbg ("auerchain_control_msg");
         dr = kmalloc (sizeof (struct usb_ctrlrequest), GFP_KERNEL);
Index: linux-2.6.21-rc5/drivers/video/matrox/matroxfb_maven.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/video/matrox/matroxfb_maven.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/drivers/video/matrox/matroxfb_maven.c	2007-04-03 17:14:55.000000000 +0100
@@ -284,7 +284,7 @@ static unsigned int matroxfb_mavenclock(
 		unsigned int* in, unsigned int* feed, unsigned int* post,
 		unsigned int* htotal2) {
 	unsigned int fvco;
-	unsigned int p;
+	unsigned int p = 0;
 
 	fvco = matroxfb_PLL_mavenclock(&maven1000_pll, ctl, htotal, vtotal, in, feed, &p, htotal2);
 	if (!fvco)
@@ -715,7 +715,7 @@ static int maven_find_exact_clocks(unsig
 	m->regs[0x82] = 0x81;
 
 	for (x = 0; x < 8; x++) {
-		unsigned int a, b, c, h2;
+		unsigned int a = 0, b = 0, c, h2 = 0;
 		unsigned int h = ht + 2 + x;
 
 		if (!matroxfb_mavenclock((m->mode == MATROXFB_OUTPUT_MODE_PAL) ? &maven_PAL : &maven_NTSC, h, vt, &a, &b, &c, &h2)) {
Index: linux-2.6.21-rc5/drivers/video/riva/riva_hw.c
===================================================================
--- linux-2.6.21-rc5.orig/drivers/video/riva/riva_hw.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/drivers/video/riva/riva_hw.c	2007-04-03 17:14:55.000000000 +0100
@@ -1238,7 +1238,7 @@ int CalcStateExt
     int            dotClock
 )
 {
-    int pixelDepth, VClk, m, n, p;
+    int pixelDepth, VClk = 0, m = 0, n = 0, p = 0;
     /*
      * Save mode parameters.
      */
Index: linux-2.6.21-rc5/fs/block_dev.c
===================================================================
--- linux-2.6.21-rc5.orig/fs/block_dev.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/fs/block_dev.c	2007-04-03 17:14:55.000000000 +0100
@@ -950,7 +950,7 @@ static int bd_claim_by_kobject(struct bl
 				struct kobject *kobj)
 {
 	int res;
-	struct bd_holder *bo, *found;
+	struct bd_holder *bo, *found = NULL;
 
 	if (!kobj)
 		return -EINVAL;
Index: linux-2.6.21-rc5/fs/jfs/jfs_txnmgr.c
===================================================================
--- linux-2.6.21-rc5.orig/fs/jfs/jfs_txnmgr.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/fs/jfs/jfs_txnmgr.c	2007-04-03 17:14:55.000000000 +0100
@@ -1923,6 +1923,8 @@ static void xtLog(struct jfs_log * log, 
 		pxd_t pxd = pxd;	/* truncated extent of xad */
 		int twm;
 
+		memset(&pxd, 0, sizeof(pxd));
+
 		/*
 		 * For truncation the entire linelock may be used, so it would
 		 * be difficult to store xad list in linelock itself.
Index: linux-2.6.21-rc5/fs/nfsd/nfsctl.c
===================================================================
--- linux-2.6.21-rc5.orig/fs/nfsd/nfsctl.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/fs/nfsd/nfsctl.c	2007-04-03 17:14:55.000000000 +0100
@@ -299,7 +299,7 @@ static ssize_t write_filehandle(struct f
 	 * qword quoting is used, so filehandle will be \x....
 	 */
 	char *dname, *path;
-	int maxsize;
+	int maxsize = 0;
 	char *mesg = buf;
 	int len;
 	struct auth_domain *dom;
Index: linux-2.6.21-rc5/fs/ocfs2/dlm/dlmdomain.c
===================================================================
--- linux-2.6.21-rc5.orig/fs/ocfs2/dlm/dlmdomain.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/fs/ocfs2/dlm/dlmdomain.c	2007-04-03 17:14:55.000000000 +0100
@@ -1031,7 +1031,7 @@ static int dlm_try_to_join_domain(struct
 {
 	int status = 0, tmpstat, node;
 	struct domain_join_ctxt *ctxt;
-	enum dlm_query_join_response response;
+	enum dlm_query_join_response response = JOIN_OK;
 
 	mlog_entry("%p", dlm);
 
Index: linux-2.6.21-rc5/fs/ocfs2/vote.c
===================================================================
--- linux-2.6.21-rc5.orig/fs/ocfs2/vote.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/fs/ocfs2/vote.c	2007-04-03 17:14:55.000000000 +0100
@@ -664,7 +664,7 @@ static int ocfs2_do_request_vote(struct 
 				 struct ocfs2_vote_msg *request,
 				 struct ocfs2_net_response_cb *callback)
 {
-	int status, response;
+	int status, response = -1;
 	unsigned int response_id;
 	struct ocfs2_msg_hdr *hdr;
 
Index: linux-2.6.21-rc5/fs/udf/balloc.c
===================================================================
--- linux-2.6.21-rc5.orig/fs/udf/balloc.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/fs/udf/balloc.c	2007-04-03 17:14:55.000000000 +0100
@@ -754,6 +754,8 @@ static int udf_table_new_block(struct su
 
 	*err = -ENOSPC;
 
+	memset(&goal_eloc, 0, sizeof(goal_eloc));
+
 	if (UDF_I_ALLOCTYPE(table) == ICBTAG_FLAG_AD_SHORT)
 		adsize = sizeof(short_ad);
 	else if (UDF_I_ALLOCTYPE(table) == ICBTAG_FLAG_AD_LONG)
Index: linux-2.6.21-rc5/fs/udf/super.c
===================================================================
--- linux-2.6.21-rc5.orig/fs/udf/super.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/fs/udf/super.c	2007-04-03 17:14:55.000000000 +0100
@@ -1362,6 +1362,8 @@ udf_load_partition(struct super_block *s
 			{
 				kernel_lb_addr ino;
 
+				memset(&ino, 0, sizeof(ino));
+
 				if (!UDF_SB_LASTBLOCK(sb))
 				{
 					UDF_SB_LASTBLOCK(sb) = udf_get_last_block(sb);
Index: linux-2.6.21-rc5/ipc/msg.c
===================================================================
--- linux-2.6.21-rc5.orig/ipc/msg.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/ipc/msg.c	2007-04-03 17:14:55.000000000 +0100
@@ -395,6 +395,8 @@ asmlinkage long sys_msgctl(int msqid, in
 	if (msqid < 0 || cmd < 0)
 		return -EINVAL;
 
+	memset(&setbuf, 0, sizeof(setbuf));
+
 	version = ipc_parse_version(&cmd);
 	ns = current->nsproxy->ipc_ns;
 
Index: linux-2.6.21-rc5/ipc/sem.c
===================================================================
--- linux-2.6.21-rc5.orig/ipc/sem.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/ipc/sem.c	2007-04-03 17:14:55.000000000 +0100
@@ -862,6 +862,8 @@ static int semctl_down(struct ipc_namesp
 	struct sem_setbuf setbuf;
 	struct kern_ipc_perm *ipcp;
 
+	memset(&setbuf, 0, sizeof(setbuf));
+
 	if(cmd == IPC_SET) {
 		if(copy_semid_from_user (&setbuf, arg.buf, version))
 			return -EFAULT;
Index: linux-2.6.21-rc5/kernel/auditfilter.c
===================================================================
--- linux-2.6.21-rc5.orig/kernel/auditfilter.c	2007-04-03 17:14:14.000000000 +0100
+++ linux-2.6.21-rc5/kernel/auditfilter.c	2007-04-03 17:14:55.000000000 +0100
@@ -1168,7 +1168,7 @@ static inline int audit_add_rule(struct 
 	struct audit_entry *e;
 	struct audit_field *inode_f = entry->rule.inode_f;
 	struct audit_watch *watch = entry->rule.watch;
-	struct nameidata *ndp, *ndw;
+	struct nameidata *ndp = NULL, *ndw = NULL;
 	int h, err, putnd_needed = 0;
 #ifdef CONFIG_AUDITSYSCALL
 	int dont_count = 0;
